# This workflow will install the python package and dependencies, and run tests against a variety of Python versions

name: Build

on:
  push:
    branches: [ master ]
  pull_request:
    branches: [ master ]
  schedule:
    - cron: "0 13 * * *"  # Every day at 1pm UTC (6am PST)

jobs:
  build:

    runs-on: ubuntu-latest
    strategy:
      matrix:
        python-version: ['3.9', '3.10', '3.11', '3.12']

    steps:
    - uses: actions/checkout@v3
    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}
    - name: Install dependencies
      run: |
        sudo apt-get update
        sudo apt-get install -y ghostscript
        python -m pip install --upgrade pip
        if [ -f requirements.txt ]; then pip install -r requirements.txt; fi          
        python -m pip install .
    - name: Test with pytest
      run: |
        python -m pytest
    - name: Lint with black and isort (run `make delint` to fix issues)
      run: |
        black --check .
        isort --check .
    - name: Lint with flake8
      run: |
        flake8 .
